import pygame
from pygame.locals import *


class TextOverlay:
	def __init__(self, game, screenoverlayed, messages):
		self.game=game
		self.bottom=screenoverlayed
		self.messageindex=0
		self.messages=messages
		self.textcolor=pygame.Color(252,252,252)
		self.font=pygame.font.Font('../fonts/PressStart2P.ttf',14)
		self.textbox=pygame.image.load('../images/textbox.png')
	def update(self):
		pass
	def handle_event(self, event):
		if event.type==MOUSEBUTTONUP and event.button==1:
			self.messageindex+=1
			if self.messageindex >= len(self.messages):
				self.game.active_screen=self.bottom
	def draw(self, window):
		self.bottom.draw(window)
		if len(self.messages)>self.messageindex:
			y=64
			message=self.messages[self.messageindex]
			#window.fill(pygame.Color(20,60,80), pygame.Rect(32,32,704, 240))
			window.blit(self.textbox, pygame.Rect(32,32,704,240))
			for part in message.split('\n'):
				blob=self.font.render(part, False, self.textcolor, pygame.Color(0,0,0))
				rect=blob.get_rect()
				rect.topleft=(64,y)
				y=rect.bottom
				window.blit(blob, rect)
	def get_music(self):
		return self.bottom.get_music()
		