import pygame
from pygame.locals import *
from screens.text import TextOverlay
from screens.game import GameScreen, GridSquare, Gun


class Tutorial:	
	def __init__(self, game):
		self.game=game
		self.gamescreen=GameScreen(game,0)
		self.donewelcometext=False
		self.progress=0
		self.input_blocked=False
		self.welcomeMessages=["Welcome to the tutorial.\n(click to continue)",
			"In this game you protect your 3 rare pearls.\nThey are located in the center of the screen.",
			"The evil ocean master is sending his minions\nto destroy your walls and take your pearls",
			"You have protected your pearls with a wall\nIt is not enough\n build another section of wall to continue\n"]
			
		self.gameplay_frozen=False
		self.donefirstpiecetext=False
		self.test_piece=None
	def update(self):
		if self.progress==0:
			self.gamescreen.nextpiece=[[GridSquare(0,0),GridSquare(0,1),GridSquare(0,2)]]
			self.gamescreen.nextpiece[0][0].haswall=True
			self.gamescreen.nextpiece[0][1].haswall=True
			self.gamescreen.nextpiece[0][2].haswall=True
			self.test_piece=self.gamescreen.nextpiece
			self.game.active_screen=TextOverlay(self.game, self, self.welcomeMessages)
			self.progress=1
		elif self.progress==1 and self.test_piece!=self.gamescreen.nextpiece:
			self.game.active_screen=TextOverlay(self.game,self, ["Good job, now place the power crystal\n to create a source of energy"])
			self.progress=2
			self.gamescreen.nextpiece=[[GridSquare(0,0),GridSquare(0,1),GridSquare(0,2),GridSquare(1,1),GridSquare(-1,1)]]
			self.gamescreen.nextpiece[0][0].haswall=True
			self.gamescreen.nextpiece[0][1].haswall=True
			self.gamescreen.nextpiece[0][0].ischargable=True
			self.gamescreen.nextpiece[0][1].ischargable=True
			self.gamescreen.nextpiece[0][2].ischargable=True
			self.gamescreen.nextpiece[0][3].ischargable=True
			self.gamescreen.nextpiece[0][4].ischargable=True
			self.gamescreen.nextpiece[0][1].ispowersource=True
			self.gamescreen.nextpiece[0][2].haswall=True
			self.gamescreen.nextpiece[0][3].haswall=True
			self.gamescreen.nextpiece[0][4].haswall=True
			self.test_piece=self.gamescreen.nextpiece
		elif self.progress==2 and self.test_piece!=self.gamescreen.nextpiece:
			self.game.active_screen=TextOverlay(self.game, self, ["The power crystal provides power\nto the neighboring connectors",
				"Now connect the gun piece to the power source\nto activate them."])
			self.gamescreen.nextpiece=[[GridSquare(0,0),GridSquare(0,1),GridSquare(0,2),GridSquare(1,1),GridSquare(-1,1)]]
			self.gamescreen.nextpiece[0][0].haswall=True
			self.gamescreen.nextpiece[0][1].haswall=True
			self.gamescreen.nextpiece[0][0].ischargable=True
			self.gamescreen.nextpiece[0][1].ischargable=True
			self.gamescreen.nextpiece[0][2].ischargable=True
			self.gamescreen.nextpiece[0][3].ischargable=True
			self.gamescreen.nextpiece[0][4].ischargable=True
			self.gamescreen.nextpiece[0][1].gun=Gun()
			self.gamescreen.nextpiece[0][2].haswall=True
			self.gamescreen.nextpiece[0][3].haswall=True
			self.gamescreen.nextpiece[0][4].haswall=True
			self.progress=3
		if self.gameplay_frozen:
			return
		else:
			self.gamescreen.update()
			
	def handle_event(self, event):
		if self.input_blocked:
			return
		else:
			self.gamescreen.handle_event(event)
	def draw(self, window):
		self.gamescreen.draw(window)
	def get_music(self):
		return self.gamescreen.get_music()
		